package ru.dbotthepony.kstarbound.client.gl.vertex

enum class GeometryType(
	/**
	 * Число вершин у одного элемента
	 */
	val elements: Int,

	/**
	 * Индекс вершин одного элемента
	 */
	val indices: IntArray
) {
	AS_IS(1, intArrayOf(0)),
	LINES(2, intArrayOf(0, 1)),
	TRIANGLES(3, intArrayOf(0, 1, 2)),

	/**
	 * A B C B C D
	 */
	QUADS(4, intArrayOf(0, 1, 2, 1, 2, 3)),

	/**
	 * A B C C D A
	 */
	QUADS_ALTERNATIVE(4, intArrayOf(0, 1, 2, 2, 3, 0)),

	QUADS_AS_LINES(4, intArrayOf(0, 1, 0, 2, 1, 3, 2, 3)),
	QUADS_AS_LINES_WIREFRAME(4, intArrayOf(0, 1, 0, 2, 1, 3, 2, 3, 0, 3, 1, 2)),
}
