package ru.dbotthepony.kstarbound.client.render

import ru.dbotthepony.kstarbound.client.gl.GLStateTracker
import ru.dbotthepony.kstarbound.client.gl.GLTexture2D
import ru.dbotthepony.kstarbound.client.gl.vertex.QuadTransformers
import ru.dbotthepony.kstarbound.defs.image.AtlasConfiguration
import ru.dbotthepony.kstarbound.defs.image.IUVCoordinates
import ru.dbotthepony.kstarbound.defs.image.ImageReference

/**
 * Связка текстуры-атласа + координат спрайта на ней
 */
class BoundSprite(
	val sprite: AtlasConfiguration.Sprite,
	val texture: GLTexture2D
) : IUVCoordinates {
	/**
	 * Настоящая ширина спрайта, в пикселях
	 */
	val width = sprite.width(texture.width)

	/**
	 * Настоящая высота спрайта, в пикселях
	 */
	val height = sprite.height(texture.height)

	override val u0: Float
	override val v0: Float
	override val u1: Float
	override val v1: Float

	init {
		val coords = sprite.compute(texture)

		this.u0 = coords.u0
		this.v0 = coords.v0
		this.u1 = coords.u1
		this.v1 = coords.v1
	}

	fun bind() = texture.bind()
	val transformer = QuadTransformers.uv(u0, v0, u1, v1)
}
