package ru.dbotthepony.kstarbound.client.render.entity

import ru.dbotthepony.kstarbound.PIXELS_IN_STARBOUND_UNITf
import ru.dbotthepony.kstarbound.client.ClientChunk
import ru.dbotthepony.kstarbound.client.StarboundClient
import ru.dbotthepony.kstarbound.client.render.RebindableSprite
import ru.dbotthepony.kstarbound.world.entities.ItemEntity
import ru.dbotthepony.kvector.matrix.Matrix4fStack

class ItemRenderer(client: StarboundClient, entity: ItemEntity, chunk: ClientChunk?) : EntityRenderer(client, entity, chunk) {
	private val def = entity.def
	private val textures = def.inventoryIcon?.stream()?.map { RebindableSprite(client, it.image) }?.toList() ?: listOf()

	override fun render(stack: Matrix4fStack) {
		if (textures.isEmpty())
			return

		state.programs.textured.use()
		state.programs.textured.transform = stack.last
		state.activeTexture = 0
		state.programs.textured.texture = 0

		for (unbound in textures) {
			val sprite = unbound.update() ?: continue
			sprite.texture.bind()
			state.flat2DTexturedQuads.singleSprite(sprite.width / PIXELS_IN_STARBOUND_UNITf, sprite.height / PIXELS_IN_STARBOUND_UNITf, entity.movement.angle, sprite.transformer)
		}
	}
}
