package ru.dbotthepony.kstarbound.defs

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.defs.animation.AnimationDefinition
import ru.dbotthepony.kstarbound.defs.image.ImageReference
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory

@JsonFactory
data class StatusEffectDefinition(
	val name: String,
	val defaultDuration: Double,
	val blockingStat: String? = null,
	val label: String? = null,
	val icon: ImageReference? = null,
	override val scripts: ImmutableList<DirectAssetReference> = ImmutableList.of(),
	override val scriptDelta: Int = 1,
	val animationConfig: AssetReference<AnimationDefinition>? = null,
) : IScriptable
