package ru.dbotthepony.kstarbound.defs.item

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.defs.DirectAssetReference
import ru.dbotthepony.kstarbound.io.json.builder.JsonBuilder
import ru.dbotthepony.kstarbound.io.json.builder.JsonIgnoreProperty

@JsonBuilder
abstract class ArmorItemPrototype : ItemPrototype(), IArmorItemDefinition {
	override var colorOptions: ImmutableList<Map<String, String>> by NotNull(ImmutableList.of())
	override var maleFrames: IArmorItemDefinition.Frames by NotNull()
	override var femaleFrames: IArmorItemDefinition.Frames by NotNull()
	override var level: Double by NotNull(1.0)
	override var leveledStatusEffects: ImmutableList<LeveledStatusEffect> by NotNull(ImmutableList.of())

	override var scripts: ImmutableList<DirectAssetReference> by NotNull(ImmutableList.of())
	override var scriptDelta: Int by NotNull(1)

	init {
		maxStack = 1L
	}
}

@JsonBuilder
class HeadArmorItemPrototype : ArmorItemPrototype()

@JsonBuilder
class ChestArmorItemPrototype : ArmorItemPrototype()

@JsonBuilder
class LegsArmorItemPrototype : ArmorItemPrototype()

@JsonBuilder
class BackArmorItemPrototype : ArmorItemPrototype()
