package ru.dbotthepony.kstarbound.defs.item

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.defs.util.enrollMap
import ru.dbotthepony.kstarbound.io.json.builder.JsonBuilder
import ru.dbotthepony.kstarbound.util.NotNullVar
import ru.dbotthepony.kvector.vector.ndouble.Vector2d

@JsonBuilder
class HarvestingToolPrototype : ItemPrototype(), IHarvestingToolDefinition {
	override var frames: Int by NotNull()
	override var animationCycle: Double by NotNull()
	override var blockRadius: Int by NotNull()
	override var altBlockRadius: Int by NotNull(0)
	override var idleSound: ImmutableList<String> by NotNull(ImmutableList.of())
	override var strikeSounds: ImmutableList<String> by NotNull(ImmutableList.of())
	override var handPosition: Vector2d by NotNull()
	override var fireTime: Double by NotNull()

	init {
		maxStack = 1L
	}
}
