package ru.dbotthepony.kstarbound.defs.item

import ru.dbotthepony.kstarbound.io.json.builder.JsonBuilder
import ru.dbotthepony.kstarbound.util.Either

@JsonBuilder
class LiquidItemPrototype : ItemPrototype(), ILiquidItem {
	private val liquidDelegate = NotNull<Either<Int, String>>()
	override var liquid: Either<Int, String> by liquidDelegate

	var liquidId: Int?
		get() = liquidDelegate.getNullable()?.left
		set(value) { if (liquidDelegate.getNullable() == null) liquid = Either.left(value!!) }

	var liquidName: String?
		get() = liquidDelegate.getNullable()?.right
		set(value) { liquid = Either.right(value!!) }

	override fun onFreeze() {
		if (liquidDelegate.getNullable() == null) {
			throw NullPointerException("no liquidId nor liquidName was defined")
		}
	}
}
