package ru.dbotthepony.kstarbound.defs.item

import ru.dbotthepony.kstarbound.io.json.builder.JsonBuilder
import ru.dbotthepony.kstarbound.util.Either

@JsonBuilder
class MaterialItemPrototype : ItemPrototype(), IMaterialItem {
	private val materialDelegate = NotNull<Either<Int, String>>()
	override var material: Either<Int, String> by materialDelegate

	var materialId: Int?
		get() = materialDelegate.getNullable()?.left
		set(value) { if (materialDelegate.getNullable() == null) material = Either.left(value!!) }

	var materialName: String?
		get() = materialDelegate.getNullable()?.right
		set(value) { material = Either.right(value!!) }

	override fun onFreeze() {
		if (material == null) {
			throw NullPointerException("no materialId nor materialName was defined")
		}
	}
}
