package ru.dbotthepony.kstarbound.defs.player

import com.google.common.collect.ImmutableSet
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory

@JsonFactory
data class InventoryFilterConfig(
	val typeBlacklist: ImmutableSet<String>? = null,
	val typeWhitelist: ImmutableSet<String>? = null,
	val tagBlacklist: ImmutableSet<String>? = null,
	val categoryBlacklist: ImmutableSet<String>? = null,
) {
	fun acceptsType(type: String): Boolean {
		if (typeBlacklist != null) {
			return !typeBlacklist.contains(type)
		} else if (typeWhitelist != null) {
			return typeWhitelist.contains(type)
		}

		return true
	}
}
