package ru.dbotthepony.kstarbound.defs.tile

import com.google.gson.GsonBuilder
import ru.dbotthepony.kstarbound.Starbound
import ru.dbotthepony.kstarbound.defs.image.ImageReference
import ru.dbotthepony.kstarbound.io.json.builder.FactoryAdapter
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory

const val TILE_COLOR_VARIANTS = 9

@JsonFactory
data class RenderParameters(
	val texture: ImageReference,
	val variants: Int = 0,
	val multiColored: Boolean = false,
	val occludesBelow: Boolean = false,
	val lightTransparent: Boolean = false,
	val zLevel: Int,
) {
	init {
		checkNotNull(texture.imagePath.value) { "Tile render parameters are stateless, but provided image is a pattern: ${texture.raw}" }
	}
}
