package ru.dbotthepony.kstarbound.defs.tile

import com.google.gson.GsonBuilder
import ru.dbotthepony.kstarbound.defs.AssetReference
import ru.dbotthepony.kstarbound.defs.IThingWithDescription
import ru.dbotthepony.kstarbound.defs.ThingDescription
import ru.dbotthepony.kstarbound.io.json.builder.FactoryAdapter
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.io.json.builder.JsonPropertyConfig
import ru.dbotthepony.kstarbound.registerTypeAdapter
import ru.dbotthepony.kvector.vector.Color

@JsonFactory
data class TileDefinition(
	val materialId: Int,
	val materialName: String,
	val particleColor: Color? = null,
	val itemDrop: String? = null,
	val footstepSound: String? = null,

	val blocksLiquidFlow: Boolean = true,
	val soil: Boolean = false,

	val health: Double = 0.0,
	val category: String,

	@JsonPropertyConfig(isFlat = true)
	val descriptionData: ThingDescription,

	override val renderTemplate: AssetReference<RenderTemplate>,
	override val renderParameters: RenderParameters,
) : IRenderableTile, IThingWithDescription by descriptionData
