package ru.dbotthepony.kstarbound.world.entities

import ru.dbotthepony.kbox2d.api.ContactImpulse
import ru.dbotthepony.kbox2d.api.FixtureDef
import ru.dbotthepony.kbox2d.api.Manifold
import ru.dbotthepony.kbox2d.collision.shapes.PolygonShape
import ru.dbotthepony.kbox2d.dynamics.contact.AbstractContact
import ru.dbotthepony.kstarbound.defs.item.IItemDefinition
import ru.dbotthepony.kstarbound.world.World

class ItemEntity(world: World<*, *>, val def: IItemDefinition) : Entity(world) {
	override val movement = object : MovementController<ItemEntity>(this) {
		override fun beginContact(contact: AbstractContact) {
			// тут надо код подбора предмета игроком, если мы начинаем коллизию с окружностью подбора
		}

		override fun endContact(contact: AbstractContact) {

		}

		override fun postSolve(contact: AbstractContact, impulse: ContactImpulse) {

		}

		override fun preSolve(contact: AbstractContact, oldManifold: Manifold) {
			if (contact.fixtureA.userData is ItemEntity && contact.fixtureB.userData is ItemEntity)
				contact.isEnabled = false
		}

		override fun onSpawnedInWorld() {
			super.onSpawnedInWorld()

			// все предметы в мире являются коробками
			val fixture = FixtureDef(
				shape = PolygonShape().also { it.setAsBox(0.75, 0.75) },
				restitution = 0.0,
				friction = 1.0,
				density = 0.3,
			)

			fixture.userData = this@ItemEntity

			body.createFixture(fixture)

			// предметы не могут поворачиваться в мире, всегда падают плашмя
			body.isFixedRotation = true
		}
	}

	override fun thinkAI(delta: Double) {
		// TODO: деспавнинг?
		// просто, как бы, предметы не должны уж так сильно нагружать процессор
	}
}
